function log_filt_dens = filt_dens_update_d_and_m(current_value, prev_particles,...
    y, z, log_filt_weights_prev, model_params, mdl_trans_mtx, t, system_type)

% log_filt_dens = filt_dens_update_d_and_m(current_value, prev_particles,...
%     y, z, log_filt_weights_prev, model_params, mdl_trans_mtx, t, system_type)
%

% Calculate the predictive density:
LP = length(prev_particles);

temp_pred_dens = zeros(1, LP);
for l = 1:LP
    log_trans_dens = trans_dens_d_and_m(current_value, ...
        prev_particles(l), model_params, mdl_trans_mtx, t);
        
    temp_pred_dens(l) = log_trans_dens + log_filt_weights_prev(l);
end
log_pred_dens = log_sum(temp_pred_dens);


% Now calculate the conditional likelihood of y(t)
if current_value.D == t-1
    log_cond_lkl = log_lkl_y(y(t), z(t), model_params{current_value.M}, system_type);
else
    log_cond_lkl = log_lkl_y(y(current_value.D+1:t), z(current_value.D+1:t),...
        model_params{current_value.M}, system_type)...
        - log_lkl_y(y(current_value.D+1:t-1), z(current_value.D+1:t-1), ...
        model_params{current_value.M}, system_type);
end

% Finally, calculate the filtering density of the given value at time t
log_filt_dens = log_pred_dens + log_cond_lkl;