function P = geometric_pdf(K, dist_params)

% P = geometric_pdf(K, dist_params)
%
% This function outputs probabilities of values in K according to the 
% geometric distribution which is determined by the success probability
% parameter 'dist_params.success_prob' and the first value of its support
% domain 'dist_params.start_pnt'.  The size of P is the common size of the
% input arguments.


% Success probability:
sp = dist_params.success_prob;
stp = dist_params.start_pnt;

% Check if the starting point is given properly:
if round(stp) == stp
    P = geopdf(K-stp, sp);
else
    error('Starting point is not an integer');
end