function l_sum = log_sum(v)

% l_sum = log_sum(v)
%
% This function calculates the logarithm of the sum of the numbers whose
% logarithms are given in the vector v in a stable way. It does the
% summation by extracting the maximum of the numbers' logarithms so that
% the arguement of the exponential function is small enough to be safe.
%


m = max(v);
if m == -inf
    l_sum = -inf;
else
    l_sum = log(sum(exp(v-m))) + m;
end