function [ind] = multinomial_res(log_w, N)

% [ind] = multinomial_res(log_w)
% 
% Multinomial resampling given the log-weights
% 


% Normalise the log weights if they are not:
log_w = log_w - log_sum(log_w);

% Convert to the linear scale
w = exp(log_w);
% Cumulative sum:
W = cumsum(w);
W = W(:)';
M = length(W);

u = rand(N, 1);
ind = sum(repmat(u, 1, M) > repmat(W, N, 1), 2) + 1;