function [part_reorg, log_w_reorg, reorg_ind, new_part_ind] = reorganize_particles(part, log_w)

% [part_reorg, log_w_reorg, reorg_ind] = reorganize_particles(part, log_w)
%


N = length(log_w);
% Initialise
log_w_reorg = zeros(1, N);
reorg_ind = zeros(1, N);
part_reorg(N) = part(1);

counter1 = 1;
part_reorg(1) = part(1);
log_w_reorg(1) = log_w(1);
reorg_ind(1) = 1;
new_part_ind = ones(1, N);

for n = 2:N
    % Get the particle values
    D = part(n).D;
    M = part(n).M;
    % Check if the particle is in the reorganised particles so far:
    counter2 = 0;
    for c = 1:counter1
        if (D == part_reorg(c).D) && (M == part_reorg(c).M)
            log_w_reorg(c) = log_sum([log_w_reorg(c), log_w(n)]);
            counter2 = 1;
            new_part_ind(n) = c;
            break;
        end
    end
    % If the particle value is new, add it to the reorganised particles
    if counter2 == 0
        counter1 = counter1 + 1;
        log_w_reorg(counter1) = log_w(n);
        part_reorg(counter1) = part(n);
        reorg_ind(counter1) = n;
        new_part_ind(n) = counter1;
    end
end
part_reorg = part_reorg(1:counter1);
log_w_reorg = log_w_reorg(1:counter1);
reorg_ind = reorg_ind(1:counter1);