function resampled_indices = resample_weights(cand_weights, weight_thr, num_thr)

% resampled_indices = resample_deter(cand_weights, weight_thr)
%
% This function performs deterministic selection for the input log-weights
% and outputs their indices. The number of surviving weights is the minimum
% of num_thr and the number of weights which are above the threshold value
% weight thr.
% 


% Normalize candidate weights if they are not:
cand_weights = cand_weights - log_sum(cand_weights);

% Sort
[b, a] = sort(cand_weights, 'descend');
% Find the number of  of weights which are above the threshold value
% weight thr.
L1 = sum(b >= weight_thr);
% Output the indices surviving weights
resampled_indices = sort(a(1:min(num_thr, L1)));